# -*- coding: utf-8 -*-
#
# Configuration file for the Sphinx documentation builder.
#
# This file does only contain a selection of the most common options. For a
# full list see the documentation:
# http://www.sphinx-doc.org/en/master/config

# -- Path setup --------------------------------------------------------------

# If extensions (or modules to document with autodoc) are in another directory,
# add these directories to sys.path here. If the directory is relative to the
# documentation root, use os.path.abspath to make it absolute, like shown here.
#
#import os
#import sys
#sys.path.insert(0, os.path.abspath('./magnumnp'))


# -- Project information -----------------------------------------------------

project = 'magnum.np'
copyright = '2023, Florian Bruckner'
author = 'Florian Bruckner'

# The short X.Y version
version = ''
# The full version, including alpha/beta/rc tags
release = '1.1.3'


# -- General configuration ---------------------------------------------------

# If your documentation needs a minimal Sphinx version, state it here.
#
# needs_sphinx = '1.0'

# Add any Sphinx extension module names here, as strings. They can be
# extensions coming with Sphinx (named 'sphinx.ext.*') or your custom
# ones.
extensions = [
    'sphinx_rtd_theme',
    'sphinx.ext.autodoc',
    'sphinx.ext.mathjax',
    'sphinx.ext.viewcode',
    'nbsphinx',
]

# Add any paths that contain templates here, relative to this directory.
templates_path = ['_templates']

# The suffix(es) of source filenames.
# You can specify multiple suffix as a list of string:
#
# source_suffix = ['.rst', '.md']
source_suffix = '.rst'

# The master toctree document.
master_doc = 'index'

# The language for content autogenerated by Sphinx. Refer to documentation
# for a list of supported languages.
#
# This is also used if you do content translation via gettext catalogs.
# Usually you set "language" from the command line for these cases.
language = 'en'

# List of patterns, relative to source directory, that match files and
# directories to ignore when looking for source files.
# This pattern also affects html_static_path and html_extra_path.
exclude_patterns = ['_build', 'Thumbs.db', '.DS_Store']

# The name of the Pygments (syntax highlighting) style to use.
pygments_style = None


# -- Options for HTML output -------------------------------------------------

# The theme to use for HTML and HTML Help pages.  See the documentation for
# a list of builtin themes.
#
html_theme = 'sphinx_rtd_theme'
#html_theme = 'pydata_sphinx_theme'
#html_logo = 'logo.png'

# Theme options are theme-specific and customize the look and feel of a theme
# further.  For a list of options available for each theme, see the
# documentation.
#
# html_theme_options = {}
#html_theme_options = {
#   "logo": {
#      "image_light": "logo.png",
#      "image_dark": "logo.png",
#   }
#}

# Add any paths that contain custom static files (such as style sheets) here,
# relative to this directory. They are copied after the builtin static files,
# so a file named "default.css" will overwrite the builtin "default.css".
html_static_path = ['_static']
#html_logo = "images/logo_magnum_np.svg"
mathjax3_config = {
        "tex": {
            "macros": {
                "vec": ["{\\mathbf #1}", 1],
                "mat": ["{\\mathbf #1}", 1],
                "dx":  "{\\;\\text{d}\\vec{x}}",
                "ds":  "{\\;\\text{d}\\vec{s}}"
                }
            }
        }

# Custom sidebar templates, must be a dictionary that maps document names
# to template names.
#
# The default sidebars (for documents that don't match any pattern) are
# defined by theme itself.  Builtin themes are using these templates by
# default: ``['localtoc.html', 'relations.html', 'sourcelink.html',
# 'searchbox.html']``.
#
# html_sidebars = {}


# -- Options for HTMLHelp output ---------------------------------------------

# Output file base name for HTML help builder.
htmlhelp_basename = 'magnumnpdoc'


# -- Options for LaTeX output ------------------------------------------------

#latex_logo = "images/logo_magnum_np.pdf"
latex_elements = {
'papersize': 'a4paper',
'pointsize': '11pt',
'classoptions': ',openany,oneside',
'babel': '\\usepackage[english]{babel}',
'preamble': r"""
 \definecolor{VerbatimBorderColor}{rgb}{1,1,1}
 \renewcommand{\vec}[1]{\boldsymbol{#1}}
 \newcommand{\mat}[1]{\boldsymbol{#1}}
 \newcommand{\dx}{\;\text{d}\boldsymbol{x}}
 \newcommand{\ds}{\;\text{d}\boldsymbol{s}}
 \usepackage{amsmath, amssymb, amsthm}
 \usepackage{bbm}
 \renewcommand{\mathbb}[1]{\mathbbm{#1}}
""",
}

# Grouping the document tree into LaTeX files. List of tuples
# (source start file, target name, title,
#  author, documentclass [howto, manual, or own class]).
latex_documents = [
    (master_doc, 'magnumnp.tex', 'magnum.np Documentation',
     'Florian Bruckner', 'manual'),
]


# -- Options for manual page output ------------------------------------------

# One entry per manual page. List of tuples
# (source start file, name, description, authors, manual section).
man_pages = [
    (master_doc, 'magnumnp', 'magnum.np Documentation',
     [author], 1)
]


# -- Options for Texinfo output ----------------------------------------------

# Grouping the document tree into Texinfo files. List of tuples
# (source start file, target name, title, author,
#  dir menu entry, description, category)
texinfo_documents = [
    (master_doc, 'magnumnp', 'magnum.np Documentation',
     author, 'magnumnp', 'One line description of project.',
     'Miscellaneous'),
]


# -- Options for Epub output -------------------------------------------------

# Bibliographic Dublin Core info.
epub_title = project

# The unique identifier of the text. This can be a ISBN number
# or the project homepage.
#
# epub_identifier = ''

# A unique identification for the text.
#
# epub_uid = ''

# A list of files that should not be packed into the epub file.
epub_exclude_files = ['search.html']


# -- Extension configuration -------------------------------------------------


# -- Options for Latex output ------------------------------------------------
#latex_logo = "images/logo_magnum_pi.pdf"
latex_elements = {
'papersize': 'a4paper',
'pointsize': '11pt',
'classoptions': ',openany,oneside',
'babel': '\\usepackage[english]{babel}',
'preamble': r"""
 \definecolor{VerbatimBorderColor}{rgb}{1,1,1}
 \renewcommand{\vec}[1]{\boldsymbol{#1}}
 \newcommand{\mat}[1]{\boldsymbol{#1}}
 \newcommand{\dx}{\;\text{d}\boldsymbol{x}}
 \newcommand{\ds}{\;\text{d}\boldsymbol{s}}
 \usepackage{amsmath, amssymb, amsthm}
 \usepackage{bbm}
 \renewcommand{\mathbb}[1]{\mathbbm{#1}}
""",
}
